// A Graphical User Interface in Java for Constraint Logic Programming
// Copyright (C) 2002 INRIA Francois Fages
// License LGPL
// http://contraintes.inria.fr/~fages/CLPgui

// 11 Jan 2002: Implementation of search trees with *reversed* lists of successors

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class SearchTree {
    public String label,property;
    public SearchTreeList children;
    public SearchTree father;
    
    SearchTree() {
	label="";
	property="";
	children=null;
	father=null;
    }
    
    SearchTree(String l) {
	label=l;
	property="";
	children=null;
	father=null;
    }
    
    public void addChild(SearchTree t) {
	children=new SearchTreeList(t,children);
	t.father=this;
    }
    
    public boolean children() {
	return (children!=null);
    }
    
    public int childNumber(SearchTree t) {
	SearchTreeList l=children;
	while (l!=null) {
	    if (l.head==t)
		return l.length();
	    else
		l=l.tail;
	}
	return 0;
    }

    public void prettyPrint() {
	System.out.print(label);
	if (children()) {
	    System.out.print("(");
	    children.revPrettyPrint();
	    System.out.print(")");
	}
    }

}

















